/// <reference types="node" />
/// <reference types="pouchdb-core" />
import uuid from './uuid';
declare type RelDB = ReturnType<typeof createRel>;
declare function setSchema<T extends {} = {}>(this: PouchDB.Database<T>, schema: any): PouchDB.RelDatabase<T>;
declare function createRel(db: PouchDB.Database, keysToSchemas: any, schema: any): {
    save: (type: any, obj: any) => Promise<{
        id: any;
        rev: string;
    }>;
    find: (type: any, idOrIds?: any) => Promise<any>;
    findHasMany: (type: any, belongsToKey: any, belongsToId: any) => Promise<any>;
    del: (type: any, obj: any) => Promise<{
        deleted: boolean;
    }>;
    getAttachment: (type: any, id: any, attachmentId: any, options?: any) => Promise<Blob | Buffer>;
    putAttachment: (type: any, obj: any, attachmentId: any, attachment: any, attachmentType: any) => Promise<string>;
    removeAttachment: (type: any, obj: any, attachmentId: any) => Promise<string>;
    parseDocID: (str: any) => {
        type: any;
        id: any;
    };
    makeDocID: (obj: any) => string;
    parseRelDocs: (type: any, pouchDocs: any) => Promise<any>;
    isDeleted: (type: any, id: any) => Promise<boolean>;
    uuid: typeof uuid;
};
declare const _default: {
    setSchema: typeof setSchema;
};
export default _default;
declare global {
    namespace PouchDB {
        interface Static {
            plugin<T extends {}>(plugin: T): Static;
        }
        interface Database<Content extends {} = {}> {
            setSchema<T extends {} = Content>(schema: any): RelDatabase<T>;
        }
        interface RelDatabase<Content extends {} = {}> extends Database<Content> {
            rel: RelDB;
        }
    }
}
